package com.gct.tool.controller;

import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.gct.tool.entity.centralbase.CbCdWellSource;
import com.gct.tool.entity.centralbase.CbPcDevWellAttr;
import com.gct.tool.entity.centralbase.CbPcProWellboreStatusDaily;
import com.gct.tool.entity.centralbase.SysAccessWellControl;
import com.gct.tool.entity.sql.QueryBody;
import com.gct.tool.entity.vo.BaseDataVo;
import com.gct.tool.entity.vo.CalRemakeVo;
import com.gct.tool.feign.AoidClient;
import com.gct.tool.feign.DataBankClient;
import com.gct.tool.feign.DiagnoseClient;
import com.gct.tool.mapper.centralbase.CbCdWellSourceMapper;
import com.gct.tool.mapper.centralbase.CbPcDevWellAttrMapper;
import com.gct.tool.mapper.centralbase.CbPcProWellboreStatusDailyMapper;
import com.gct.tool.mapper.centralbase.SysAccessWellControlMapper;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import java.time.LocalDate;
import java.time.LocalDateTime;
import java.time.format.DateTimeFormatter;
import java.util.*;

/**
 * @author xusirui 2023/12/17
 */
//@CrossOrigin
@RestController
@RequestMapping("/base-data")
public class BaseDataController {

    @Autowired
    CbPcProWellboreStatusDailyMapper cbPcProWellboreStatusDailyMapper;

    @Autowired
    CbPcDevWellAttrMapper cbPcDevWellAttrMapper;

    @Autowired
    DiagnoseClient diagnoseClient;

    @Autowired
    AoidClient aoidClient;

    @PostMapping("/update/status")
    public JSONObject updateStatusData(@RequestBody BaseDataVo baseDataVo) {
        if (Objects.nonNull(baseDataVo.getYy()) || Objects.nonNull(baseDataVo.getTy())
                || Objects.nonNull(baseDataVo.getBs()) || Objects.nonNull(baseDataVo.getBj())
                || Objects.nonNull(baseDataVo.getDym())) {
            CbPcProWellboreStatusDaily cbPcProWellboreStatusDaily = new CbPcProWellboreStatusDaily();
            cbPcProWellboreStatusDaily.setPumpDepth(baseDataVo.getBs());
            cbPcProWellboreStatusDaily.setOilNozzle(baseDataVo.getBj());
            cbPcProWellboreStatusDaily.setStartPumpLiqLevel(baseDataVo.getDym());
            cbPcProWellboreStatusDaily.setTubingPres(baseDataVo.getYy());
            cbPcProWellboreStatusDaily.setCasingPres(baseDataVo.getTy());

            cbPcProWellboreStatusDailyMapper.update(cbPcProWellboreStatusDaily,
                    new QueryWrapper<CbPcProWellboreStatusDaily>().eq("well_id", baseDataVo.getWellId()));
            String nowDateTimeStr = LocalDateTime.now().format(DateTimeFormatter.ofPattern("yyyy-MM-dd HH:mm:ss"));
            String nowMinus8DateTimeStr = LocalDateTime.now().minusDays(8).format(DateTimeFormatter.ofPattern("yyyy-MM-dd HH:mm:ss"));
            String nowDateStr = LocalDate.now().format(DateTimeFormatter.ISO_DATE);
            String nowMinus8DateStr = LocalDate.now().minusDays(8).format(DateTimeFormatter.ISO_DATE);
        }
        JSONObject obj = new JSONObject();
        obj.put("status",1);
        obj.put("data","ok");
        return obj;
    }

    @PostMapping("/update/attr")
    public String updateWellAttr(@RequestBody CbPcDevWellAttr cbPcDevWellAttr) {
        if (Objects.nonNull(cbPcDevWellAttr.getCoefficient())) {
            cbPcDevWellAttrMapper.update(cbPcDevWellAttr, new QueryWrapper<CbPcDevWellAttr>().eq("well_id", cbPcDevWellAttr.getWellId()));
            String nowDateStr = LocalDate.now().format(DateTimeFormatter.ISO_DATE);
            String nowMinus8DateStr = LocalDate.now().minusDays(8).format(DateTimeFormatter.ISO_DATE);
            aoidClient.CalculateProdDateData(new CalRemakeVo(new ArrayList<>(), cbPcDevWellAttr.getWellId(), nowDateStr, nowMinus8DateStr));
        }
        return "{data: \"ok\"}";
    }

    final String governDataServiceIdentity = "CDF03A45C9BF4D9B85155364FAAEE08C14D85F6D51774A59GMXF6MBQG4ZDOKZXL4YF6KZSGEZGEKZWMBQTMKZVL43WCYJVG4XWCMLDGUXT22DKO43TAZ3CMYXXEL3AMFWWWN3ROFXGEZZSONYDAMBTGEYTKLRVGEZTONZXFYXTAMBSF4YDAMQ";

    @Autowired
    DataBankClient dataBankClient;

    @Autowired
    CbCdWellSourceMapper cbCdWellSourceMapper;

    @Autowired
    SysAccessWellControlMapper sysAccessWellControlMapper;

    @PostMapping("/well/add")
    public String addNewWell(@RequestBody BaseDataVo  baseDataVo){

        Set<String> filterSet = new HashSet<>();
        JSONObject res = new JSONObject();
        filterSet.addAll(Arrays.asList("WELL_ID", "WELL_COMMON_NAME", "WELL_LEGAL_NAME"));
        QueryBody queryBody = new QueryBody();
        queryBody.select("TL").eq("WELL_LEGAL_NAME", baseDataVo.getWellLegalName());
        JSONObject object = dataBankClient.getCdWellData(queryBody.toJsonMap(), 0, 10, governDataServiceIdentity);
        JSONArray array = object.getJSONObject("resultData").getJSONArray("content");
        if (Objects.isNull(baseDataVo.getOrgId())) {
            res.put("status",-1);
            res.put("message","未选择井所属的作业区");
        }
        if (array.isEmpty()) {
            res.put("status",-1);
            res.put("message","添加失败, 未找到井消息");
            return res.toJSONString();
        }

        JSONObject wellObj = array.getJSONObject(0);
        CbCdWellSource wellSource = new CbCdWellSource();
        wellSource.setWellId(wellObj.getString("WELL_ID"));
        wellSource.setWellLegalName(wellObj.getString("WELL_LEGAL_NAME"));
        wellSource.setWellCommonName(wellObj.getString("WELL_COMMON_NAME"));
        wellSource.setOrgId(baseDataVo.getOrgId());
        CbCdWellSource wellSource1 = cbCdWellSourceMapper.selectOne(new QueryWrapper<CbCdWellSource>().eq("well_id", wellSource.getWellId()));
        if (Objects.nonNull(wellSource1)){
            res.put("status",-1);
            res.put("message","添加失败, 井已存在");
            return res.toJSONString();
        }
        List<CbCdWellSource> cbCdWellSources = cbCdWellSourceMapper.selectList(new QueryWrapper<CbCdWellSource>().eq("org_id", baseDataVo.getOrgId()));
        if (!cbCdWellSources.isEmpty()){
            wellSource.setStationId(cbCdWellSources.get(0).getStationId());
        }
        cbCdWellSourceMapper.insert(wellSource);
        DateTimeFormatter df = DateTimeFormatter.ofPattern("yyyy-MM-dd HH:mm:ss");
        CbPcProWellboreStatusDaily cbPcProWellboreStatusDaily = new CbPcProWellboreStatusDaily();
        cbPcProWellboreStatusDaily.setWellId(wellSource.getWellId());
        cbPcProWellboreStatusDaily.setPumpDepth(baseDataVo.getBs());
        cbPcProWellboreStatusDaily.setOilNozzle(baseDataVo.getBj());
        cbPcProWellboreStatusDaily.setStartPumpLiqLevel(baseDataVo.getDym());
        cbPcProWellboreStatusDaily.setTubingPres(baseDataVo.getYy());
        cbPcProWellboreStatusDaily.setCasingPres(baseDataVo.getTy());
        for (LocalDateTime begin = LocalDateTime.parse("2023-11-01 00:00:00",df);
             begin.isBefore(LocalDateTime.parse("2024-11-01 00:00:00",df));
             begin = begin.plusDays(1)){
             cbPcProWellboreStatusDaily.setProdDate(begin);
             cbPcProWellboreStatusDailyMapper.insert(cbPcProWellboreStatusDaily);
        }

        CbPcDevWellAttr cbPcDevWellAttr = new CbPcDevWellAttr();
        cbPcDevWellAttr.setWellId(wellSource.getWellId());
        cbPcDevWellAttr.setOilProductsSorting("1");
        cbPcDevWellAttr.setOilProductionMethod("3");
        cbPcDevWellAttr.setMarkedParmExplain("{\"explain\":\"null\",\"date\":\"null\",\"trend\":\"null\",\"count\":\"null\"}");
        cbPcDevWellAttr.setCoefficient(1d);
        cbPcDevWellAttr.setViscosity(30d);
        cbPcDevWellAttr.setUpdateTime("2023-01-01 00:00:00");
        cbPcDevWellAttr.setJobSystem("常规");
        cbPcDevWellAttr.setMarkedBy("初始系数");
        cbPcDevWellAttrMapper.insert(cbPcDevWellAttr);

        SysAccessWellControl sysAccessWellControl = new SysAccessWellControl();
        sysAccessWellControl.setWellId(wellSource.getWellId());
        sysAccessWellControl.setWellCommonName(wellSource.getWellCommonName());
        sysAccessWellControl.setAccessStatus(1);
        sysAccessWellControl.setAccessDate(LocalDateTime.now());
        sysAccessWellControl.setOrgId(baseDataVo.getOrgId());
        sysAccessWellControlMapper.insert(sysAccessWellControl);
        res.put("status",1);
        res.put("message","添加成功");
        return res.toJSONString();
    }
}
