package com.gct.tool.entity.centralbase;

import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableName;
import com.baomidou.mybatisplus.extension.activerecord.Model;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.NoArgsConstructor;

import java.io.Serializable;
import java.time.LocalDateTime;

/**
 * <p>
 * 开发井基础数据
 * </p>
 *
 * @author wsy
 * @since 2021-01-19
 */
@Data
@EqualsAndHashCode(callSuper = false)
@ApiModel(value="CbPcDevWellAttr对象", description="开发井基础数据")
@TableName("centralbase.cb_pc_dev_well_attr")
@NoArgsConstructor
@AllArgsConstructor

public class CbPcDevWellAttr extends Model<CbPcDevWellAttr> {

    private static final long serialVersionUID=1L;

    private String wellId;

    @ApiModelProperty(value = "机构ID;")
    private String orgId;

    @ApiModelProperty(value = "开采层系ID")
    private String producingZoneId;

    @ApiModelProperty(value = "开发井网ID")
    private String devPattternId;

    @ApiModelProperty(value = "油品分类")
    private String oilProductsSorting;

    @ApiModelProperty(value = "量油方式")
    private String testType;

    @ApiModelProperty(value = "量油常数")
    private String prodMeterCons;

    @ApiModelProperty(value = "投产措施;投产时的措施，0：无措施正常投产，1：压力投产，2：酸化投产")
    private String startProdStitum;

    @ApiModelProperty(value = "采油方式")
    private String oilProductionMethod;

    @ApiModelProperty(value = "注入方式")
    private String injectionMethod;

    @ApiModelProperty(value = "工作制度;工作制度，提捞井的需求，填写提捞周期")
    private String jobSystem;

    @ApiModelProperty(value = "投产日期")
    private LocalDateTime prodDate;

    @ApiModelProperty(value = "气油比;计算产气量用  m^3/t")
    private Double gasOilRatio;

    @ApiModelProperty(value = "水气比  t/10^4m^3")
    private Double waterGasRatio;

    @ApiModelProperty(value = "报废原因")
    private String abandonReason;

    @ApiModelProperty(value = "报废方式")
    private String abandonType;

    @ApiModelProperty(value = "井底真垂直深度")
    private Double bhTvd;

    @ApiModelProperty(value = "井底测深")
    private Double bhMd;

    @ApiModelProperty(value = "是否是斜井，填写Y或N")
    private String isDeviated;

    @ApiModelProperty(value = "井身质量")
    private String endStatus;

    @ApiModelProperty(value = "井口粘度")
    private double viscosity;

    @ApiModelProperty(value = "膨胀系数")
    private Double coefficient;

    @ApiModelProperty(value = "是否匹配")
    private String ismatching;

    @ApiModelProperty(value = "更新时间")
    private String updateTime;

    @ApiModelProperty(value = "标记人")
    private String markedBy;

    @ApiModelProperty(value = "标定参数说明")
    private String markedParmExplain;


    @ApiModelProperty(value = "是否匹配次数")
    @TableField(exist = false)
    private Integer  iscount;

    @ApiModelProperty(value = "匹配")
    @TableField(exist = false)
    private Integer  pp;

    @ApiModelProperty(value = "不匹配")
    @TableField(exist = false)
    private Integer  ispp;

    @ApiModelProperty(value = "其它")
    @TableField(exist = false)
    private Integer  qt;

    @ApiModelProperty(value = "日产液量 t")
    @TableField(exist = false)
    private Double liqProdDaily;

    @ApiModelProperty(value = "参数说明")
    @TableField(exist = false)
    private String  explain;



    @Override
    protected Serializable pkVal() {
        return null;
    }

}
